/*
 *  Copyright 2012 Anyware Services
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

function onYouTubeIframeAPIReady ()
{
	for (var i=0; i < ytPlayer_array.length; i++)
	{
		var playerId = ytPlayer_array[i][0];
		var playlistId = ytPlayer_array[i][1];
		
		eval('ytPlayer_' + playerId + '= new YT.Player("' + playerId + '", {height: ' + ytPlayer_array[i][2] + ', width: ' + ytPlayer_array[i][3] +', playerVars: {autoplay: 0}, events: {onReady: function ()  {onPlayerReady ("' + playerId + '", "' + playlistId + '")}}});');
	}
}

var ytPlayer_array = ytPlayer_array || [];

function onPlayerReady (playerId, playlistId)
{
	if (navigator.userAgent.match(/mobile/i)  || ($j.browser.msie  && parseInt($j.browser.version, 10) === 7)) { 
		// do nothing
	}
	else
	{
		eval('ytPlayer_' + playerId).loadPlaylist({
			list: playlistId,
	        listType: 'playlist',
	        index: 0,
	        startSeconds: 0
	    });
	}
}

function displayPlayList (uniqueId, playlistId, apiKey)
{
	var divPlayer = $j('#player_' + uniqueId);
	var w = divPlayer.parent().width();
	var oW = divPlayer.outerWidth(true);
	
	var playlistUniqueId = uniqueId;
	if(uniqueId.indexOf('_old') != -1)
	{
		playlistUniqueId = uniqueId.substring(0, uniqueId.indexOf('_old'));
	}
	
	var list = $j('#playlist_' + playlistUniqueId);
	var listW = w - oW; 
	if (listW < 200)
	{
		list.width(w);
	}
	else
	{
		list.width(listW);
	}
	list.show();
	
	addVideos (uniqueId, playlistId, apiKey, null);
}

function addVideos (uniqueId, playlistId, apiKey, pageToken)
{
	var playlistURL = 'https://www.googleapis.com/youtube/v3/playlistItems?part=snippet&maxResults=50&playlistId=' + playlistId + '&key=' + apiKey;
	if (pageToken != null)
	{
		playlistURL += "&pageToken=" + pageToken;
	}

	var playlistUniqueId = uniqueId;
	if(uniqueId.indexOf('_old') != -1)
	{
		playlistUniqueId = uniqueId.substring(0, uniqueId.indexOf('_old'));
	}
	
	$j.getJSON(playlistURL, function(data)
	{
		if (data.items != null)
		{
			$j.each(data.items, function(i, item)
			{
				var title = item.snippet.title.replace(/'/g,"&#039;").replace(/"/g,"&#034;");
				var videoID = item.snippet.resourceId.videoId;
				var thumb = item.snippet.thumbnails.default.url;
				var position = item.snippet.position;
				
			    var videoData = $j.ajax({
			    	url: 'https://www.googleapis.com/youtube/v3/videos?id=' + videoID + '&part=contentDetails&key=' + apiKey,
					dataType : "json",
					async: false
				}).always();
			    var temps = $j.parseJSON(videoData.responseText).items[0].contentDetails.duration;
			    temps = temps.substring(2).toLowerCase();
				$j('#playlist_' + playlistUniqueId).append("<li><a title='" + title + "' href='#player_" + uniqueId + "_begin' onclick='javascript:loadVideo(\"player_" + uniqueId + "\"," + position + ",\"" + videoID + "\"); return true;'><img alt='" + title + "' src='" + thumb + "'/><span class='title'>" + title + "</span><span class='time'>" + temps + "</span></a></li>");
			});
		}
		
		if (data.nextPageToken)
		{
			addVideos (uniqueId, playlistId, apiKey, data.nextPageToken);
		}
	});
}

function loadVideo(playerId, pos, videoID)
{
	if (navigator.userAgent.match(/mobile/i) || ($j.browser.msie  && parseInt($j.browser.version, 10) === 7)) 
	{
		document.getElementById(playerId).setAttribute("src", (document.location.protocol == 'https:' ? 'https:' : 'http:') + "//www.youtube.com/embed/"+ videoID +"");      
	}
	else 
	{
		playVideo(playerId, pos);
	}
}

// This function is called instead of onYouTubeIframeAPIReady, if HTML5 postMessage function is not supported
function createSWFObjectPlayer (uniqueId, playlistID, apiKey, playerWidth, playerHeight, theme, color)
{
	var playlistURL = 'https://www.googleapis.com/youtube/v3/playlistItems?part=contentDetails&maxResults=1&playlistId=' + playlistId + '&key=' + apiKey;
	$j.getJSON(playlistURL, function(data)
	{
		var videoID = "";
		if (data.items != null && data.items.length > 0)
		{
			var item = data.items[0];
			
			videoID = item.videoId;
		}

		var params = { allowScriptAccess: "always" };
		var atts = { id: "ytPlayer_player_" + uniqueId};
		// All of the magic handled by SWFObject (http://code.google.com/p/swfobject/)
		swfobject.embedSWF((document.location.protocol == 'https:' ? 'https:' : 'http:') + "//www.youtube.com/embed/videoseries?enablejsapi=1&listType=playlist&version=3&autoplay=1&autohide=1&theme=" + theme + "&color=" + color + "&list=" + playlistID + "&video_id=" + videoID,
		                   "player_" + uniqueId, playerWidth, playerHeight, "9", null, null, params, atts);
	});
}

function playVideo (playerId, videoIndex)
{
	eval('var player = ytPlayer_' + playerId);
	player.playVideoAt(videoIndex);
}
